import $ from 'jquery';

import 'lazysizes';

import 'lazysizes/plugins/bgset/ls.bgset';

import Polyfills from './polyfills';

export default class Lazy {
	constructor() {
		if (this.test()) {
			Polyfills.picturefill(this.load);
		}
	}

	test() {
		return $('.lazyload').length ? true : false;
	}

	load() {
		document.addEventListener('lazybeforeunveil', (e) => {
			$(e.target)
				.filter('[data-bg]')
				.css('background-image', 'url(' + $(e.target).data('bg') + ')');
		});

		if (typeof window.lazySizesConfig !== 'undefined' && typeof $.mq !== 'undefined') {
			var customMedia = {};

			$.each($.mq.getBreakpoints(), (rule, queries) => {
				var mqIndex = queries.indexOf(' and ');

				if (mqIndex > 0) {
					customMedia['-' + rule + '-'] = queries;
					customMedia['--' + rule] = queries.slice(0, mqIndex);
					customMedia[rule + '--'] = queries.slice(mqIndex + 5);
				} else if (queries.indexOf('max-width') > 0) {
					customMedia[rule + '--'] = queries;
				} else {
					customMedia['--' + rule] = queries;
				}
			});

			if (!$.isEmptyObject(customMedia)) {
				window.lazySizesConfig.customMedia = customMedia;
			}

			window.lazySizes.init();
		} else {
			window.lazySizes.init();
		}
	}
}