import $ from 'jquery';

class _Polyfills {
	constructor() {
		this.placeholder();
	}

	placeholder() {
		if (!window.feature.placeholder) {
			$.getScript('//cdnjs.cloudflare.com/ajax/libs/placeholders/4.0.1/placeholders.min.js');
		}
	}

	io(callback) {
		if (callback === undefined) {
			return false;
		}

		if (!window.IntersectionObserver) {
			$.getScript(
				'//polyfill.io/v2/polyfill.min.js?features=IntersectionObserver',
				() => callback()
			);
		} else {
			callback();
		}
	}

	picturefill(callback) {
		if (callback === undefined) {
			return false;
		}

		if (!window.feature.pictureElement || !window.feature.srcset) {
			$.getScript(
				'//cdn.jsdelivr.net/npm/picturefill@3.0.3/dist/picturefill.min.js',
				() => callback()
			);

			$('html').addClass('pictureelement srcset');
		} else {
			callback();
		}
	}

	matchMedia(callback) {
		if (callback === undefined) {
			return false;
		}

		if (!window.feature.matchMedia || !window.feature.addEventListener) {
			$.getScript(
				'//cdn.jsdelivr.net/npm/matchmedia-polyfill@0.3.1/' +
				'matchMedia.js',
				() => {
					if (!window.feature.addeventlistener) {
						$.getScript(
							'//cdn.jsdelivr.net/npm/matchmedia-polyfill@0.3.1/' +
							'matchMedia.addListener.js',
							() => callback()
						);
					} else {
						callback();
					}

					$('html').addClass('matchmedia addeventlistener');
				}
			);
		} else {
			callback();
		}
	}
}

const Polyfills = new _Polyfills();

export default Polyfills;
